package com.steerinfo.dil.controller;

import com.steerinfo.dil.model.AmsPurchaseOrder;
import com.steerinfo.dil.service.IAmsPurchaseOrderService;
import com.steerinfo.dil.service.impl.AmsPurchaseOrderServiceImpl;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * AmsPurchaseOrder RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-19 09:22
 * 类描述
 * 修订历史：
 * 日期：2021-08-19
 * 作者：generator
 * 参考：
 * 描述：AmsPurchaseOrder RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/amspurchaseorders")
public class AmsPurchaseOrderController extends BaseRESTfulController {

    @Autowired
    AmsPurchaseOrderServiceImpl amsPurchaseOrderService;

    /**
     * 采购订单生成
     * @param amsPurchaseOrder
     * @return
     */
    @ApiOperation(value="添加采购订单")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "amsPurchaseOrder", value = "采购订单", required = false, dataType = "AmsPurchaseOrder")
    })
    @PostMapping(value = "/insertAmsPurchaseOrder")
    public RESTfulResult insertAmsPurchaseOrder(@RequestBody AmsPurchaseOrder amsPurchaseOrder){
        System.out.println(amsPurchaseOrder);
        int i = amsPurchaseOrderService.insertAmsPurchaseOrder(amsPurchaseOrder);
        return success(i);
    }

    /**
     * 通过主键删除采购订单
     * @param purchaseOrderId
     * @return
     */
    @ApiOperation(value="通过主键删除采购订单")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "purchaseOrderId", value = "采购订单号", required = false, dataType = "BigDecimal")
    })
    @PostMapping(value = "/deleteAmsPurchaseOrderByPurchaseOrderId")
    public RESTfulResult deleteAmsPurchaseOrderByPurchaseOrderId(@RequestParam BigDecimal purchaseOrderId){
        int i = amsPurchaseOrderService.deleteAmsPurchaseOrderByPurchaseOrderId(purchaseOrderId);
        return success(i);
    }

    /**
     * 通过主键修改采购订单
     * @param amsPurchaseOrder
     * @return
     */
    @ApiOperation(value="通过主键修改采购订单")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "amsPurchaseOrder", value = "采购订单", required = false, dataType = "AmsPurchaseOrder")
    })
    @PostMapping(value = "/updateAmsPurchaseOrderByPurchaseOrderId")
    public RESTfulResult updateAmsPurchaseOrderByPurchaseOrderId(@RequestBody AmsPurchaseOrder amsPurchaseOrder){
        int i = amsPurchaseOrderService.updateAmsPurchaseOrderByPurchaseOrderId(amsPurchaseOrder);
        return success(i);
    }

    /**
     * 通过主键查询采购订单
     * @param purchaseOrderId
     * @return
     */
    @ApiOperation(value="通过主键查询采购订单")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "purchaseOrderId", value = "采购订单号", required = false, dataType = "BigDecimal")
    })
    @PostMapping(value = "/getAmsPurchaseOrderByPurchaseOrderId")
    public RESTfulResult getAmsPurchaseOrderByPurchaseOrderId(@RequestParam BigDecimal purchaseOrderId){
        AmsPurchaseOrder amsPurchaseOrder = amsPurchaseOrderService.getAmsPurchaseOrderByPurchaseOrderId(purchaseOrderId);
        return success(amsPurchaseOrder);
    }
}
