package com.steerinfo.dil.controller;

import com.alibaba.fastjson.JSON;
import com.steerinfo.dil.feign.ColumnDataFeign;
import com.steerinfo.dil.feign.ESFeign;
import com.steerinfo.dil.model.TmstrainLoadingResult;
import com.steerinfo.dil.service.ITmstrainLoadingResultService;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * TmstrainLoadingResult RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-30 02:23
 * 类描述
 * 修订历史：
 * 日期：2021-08-30
 * 作者：generator
 * 参考：
 * 描述：TmstrainLoadingResult RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/tmstrainloadingresults")
public class TmstrainLoadingResultController extends BaseRESTfulController {

    @Autowired
    ITmstrainLoadingResultService tmstrainLoadingResultService;

    @Autowired
    ColumnDataFeign columnDataFeign;

    @Autowired
    ESFeign esFeign;

    @Autowired
    ColumnDataUtil columnDataUtil;

    @ApiOperation(value = "查询装车作业信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(58)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping("/getTmstrainWagonLoad")
    public RESTfulResult getTmstrainWagonLoad(@RequestBody(required = false) Map<String, Object> mapValue,
                                              Integer apiId,
                                              Integer pageNum,
                                              Integer pageSize,
                                              Integer resultType) {
        //初始化过滤
        List<Map<String, Object>> wagonLoadList = null;
        //如果有条件查询则跳过初始化，和创建索引
        if (mapValue.size() == 0) {
            mapValue.put("resultType", resultType);
            //将查询结果存入索引中
            wagonLoadList = tmstrainLoadingResultService.getTmstrainWagonLoad(mapValue);
            Map<String, Object> map = new HashMap<>();
            //添加索引
            map.put("index", "get_tmstrain_wagon_load");
            //添加id
            map.put("indexId", "trainLoadingId");
            wagonLoadList.add(map);
            //新建索引
            String s = JSON.toJSONString(wagonLoadList);
            esFeign.insertIndex(wagonLoadList);
            //删除
            wagonLoadList.remove(wagonLoadList.size() - 1);
        }
        if (wagonLoadList == null) {
            mapValue.put("resultType", resultType);
            wagonLoadList = tmstrainLoadingResultService.getTmstrainWagonLoad(mapValue);
        }
        PageHelper.startPage(pageNum, pageSize);
        List<Map<String, Object>> tmstrainWagonLoad1 = tmstrainLoadingResultService.getTmstrainWagonLoad(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, wagonLoadList, tmstrainWagonLoad1);
        return success(pageList);
    }

    @PostMapping("/getTmstrainWagonLoad/{apiId}")
    public RESTfulResult getTmstrainWagonLoadByCon(@PathVariable("apiId") Integer apiId,
                                                   @RequestBody(required = false) Map<String, Object> mapValue,
                                                   Integer pageNum,
                                                   Integer pageSize,
                                                   Integer resultType,
                                                   String con) {

        mapValue.put("resultType", resultType);
        //设置要查询的索引名称
        String index = "get_tmstrain_wagon_load";
        //获取查询结果
        PageListAdd list = esFeign.getConResult(mapValue, index, apiId, pageNum, pageSize, con);
        return success(list);
    }

    /**
     * 新增车皮装车作业实绩
     *
     * @param tmstrainLoadingResult
     * @return
     */
    @ApiOperation(value = "新增车皮装车作业实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "tmstrainLoadingResult", value = "车皮装车对象", required = false, dataType = "TmstrainLoadingResult")
    })
    @PostMapping(value = "/insertTmstrainLoadingResult")
    public RESTfulResult insertTmstrainLoadingResult(@RequestBody(required = false) TmstrainLoadingResult tmstrainLoadingResult) {

        int i = tmstrainLoadingResultService.addTmstrainLoadingResult(tmstrainLoadingResult);
        return success(i);
    }

    /**
     * 通过主键查询车皮装车作业信息
     *
     * @param resultId
     * @return
     */
    @ApiOperation(value = "通过主键查询车皮装车作业信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "resultId", value = "车皮装车主键", required = false, dataType = "BigDecimal")
    })
    @PostMapping(value = "/getTmstrainLoadingResultByResultId/{resultId}")
    public RESTfulResult getTmstrainLoadingResultByResultId(@PathVariable("resultId") BigDecimal resultId) {
        List<Map<String, Object>> loadingResultByResultId = tmstrainLoadingResultService.getTmstrainLoadingResultByResultId(resultId);
        System.out.println(loadingResultByResultId);
        return success(loadingResultByResultId);
    }

    /**
     * 通过主键修改车皮装车作业实绩
     *
     * @param tmstrainLoadingResult
     * @return
     */
    @ApiOperation(value = "通过主键修改车皮装车作业实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "tmstrainLoadingResult", value = "修改车皮装车map", required = false, dataType = "TmstrainWagonLoadResult")
    })
    @PostMapping(value = "/upadteTmstrainLoadingResultByResultId")
    public RESTfulResult upadteTmstrainLoadingResultByResultId(@RequestBody(required = false) TmstrainLoadingResult tmstrainLoadingResult) {
        int i = tmstrainLoadingResultService.updateTmstrainLoadingResult(tmstrainLoadingResult);
        return success(i);
    }

    /**
     * 通过主键删除车皮装车作业实绩
     *
     * @param resultId
     * @return
     */
    @ApiOperation(value = "通过主键删除车皮装车作业实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "resultId", value = "主键ID", required = false, dataType = "BigDecimal")
    })
    @PostMapping(value = "/deleteTmstrainLoadingResultByResultId")
    public RESTfulResult deleteTmstrainLoadingResultByResultId(@RequestParam BigDecimal resultId) {
        int i = tmstrainLoadingResultService.deleteTmstrainLoadingResultByResultId(resultId);
        return success(i);
    }

    /**
     * 获取发站地点名称
     *
     * @param
     * @return
     */
    @ApiOperation(value = "获取发站地点名称")
    @ApiImplicitParams({
    })
    @GetMapping(value = "/getSendStationName")
    public RESTfulResult getSendStationName() {

        return success(tmstrainLoadingResultService.getSendStationName());
    }

    /**
     * 获取到站地点名称
     *
     * @param
     * @return
     */
    @ApiOperation(value = "获取到站地点名称")
    @GetMapping(value = "/getArrivalStationName")
    public RESTfulResult getArrivalStationName() {
        return success(tmstrainLoadingResultService.getArrivalStationName());
    }

    /**
     * 获取批次ID
     *
     * @param
     * @return
     */
    @ApiOperation(value = "获取批次ID")
    @GetMapping(value = "/getBatchId")
    public RESTfulResult getBatchId() {
        return success(tmstrainLoadingResultService.getBatchId());
    }

    /**
     * 获取装车车皮号
     *
     * @param
     * @return
     */
    @ApiOperation(value = "获取已装车还未卸车车皮")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(213)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping(value = "/getWagonNo/{resultType}")
    public RESTfulResult getWagonNo(@PathVariable("resultType") Integer resultType,
                                    @RequestBody(required = false) Map<String, Object> mapValue,
                                    Integer apiId,
                                    Integer pageNum,
                                    Integer pageSize) {
        mapValue.put("resultType", resultType);
        //不分页筛选数据
        List<Map<String, Object>> allWagonNo = tmstrainLoadingResultService.getWagonNo(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> wagonNo = tmstrainLoadingResultService.getWagonNo(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allWagonNo,wagonNo);
        return success(pageList);
    }


    //内转物流新增装车
    @ApiOperation(value = "内转物流新增装车")
    @GetMapping(value = "/addTrainLoadResultForConverted")
    public RESTfulResult addTrainLoadResultForConverted(TmstrainLoadingResult tmstrainLoadingResult) {
        return success(tmstrainLoadingResultService.addTrainLoadResultForConverted(tmstrainLoadingResult));
    }

    /**
     * 内转物流通过主键查询车皮装车作业信息
     *
     * @param resultId
     * @return
     */
    @ApiOperation(value = "内转物流通过主键查询车皮装车作业信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "resultId", value = "车皮装车主键", required = false, dataType = "BigDecimal")
    })
    @PostMapping(value = "/selectLoadByResultId/{resultId}")
    public RESTfulResult selectLoadByResultId(@PathVariable("resultId") BigDecimal resultId) {
        List<Map<String, Object>> loadingResultByResultId = tmstrainLoadingResultService.selectLoadByResultId(resultId);
        System.out.println(loadingResultByResultId);
        return success(loadingResultByResultId);
    }

    /**
     * 内转展示车皮装车实绩
     */

    @ApiOperation(value = "查询装车作业信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(203)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping("/getTmstrainWagonLoadForConverted")
    public RESTfulResult getTmstrainWagonLoadForConverted(@RequestBody(required = false) Map<String, Object> mapValue,
                                                          Integer apiId,
                                                          Integer pageNum,
                                                          Integer pageSize) {
        //初始化过滤
        List<Map<String, Object>> wagonLoadForConverted = null;
        //如果有条件查询则跳过初始化，和创建索引
        if (mapValue == null) {
            //将查询结果存入索引中
            wagonLoadForConverted = tmstrainLoadingResultService.selectLoadedForConverted(null);
            Map<String, Object> map = new HashMap<>();
            //添加索引
            map.put("index", "get_wagon_load_converted");
            //添加id
            map.put("indexId", "result2");
            wagonLoadForConverted.add(map);
            //新建索引
            String s = JSON.toJSONString(wagonLoadForConverted);
            esFeign.insertIndex(wagonLoadForConverted);
            //删除
            wagonLoadForConverted.remove(wagonLoadForConverted.size() - 1);
        }
        if (wagonLoadForConverted == null) {
            wagonLoadForConverted = tmstrainLoadingResultService.selectLoadedForConverted(mapValue);
        }
        PageHelper.startPage(pageNum, pageSize);
        List<Map<String, Object>> tmstrainWagonLoad1 = tmstrainLoadingResultService.selectLoadedForConverted(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, wagonLoadForConverted, tmstrainWagonLoad1);
        return success(pageList);
    }

    @PostMapping("/getTmstrainWagonLoadForConverted/{apiId}")
    public RESTfulResult getWagonLoadForConvertedByCon(@PathVariable("apiId") Integer apiId,
                                            @RequestBody(required = false) Map<String, Object> mapValue,
                                            Integer pageNum,
                                            Integer pageSize,
                                            String con) {
        if (mapValue == null) {
            mapValue = new HashMap<>();
        }
        //设置要查询的索引名称
        String index = "get_wagon_load_converted";
        //获取查询结果
        PageListAdd list = esFeign.getConResult(mapValue, index, apiId, pageNum, pageSize, con);
        return success(list);
    }
}
